import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ship here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PlayerShip extends Mover
{    
    private Turret turret1;  
    private Turret turret2;
    private Turret turret3;
    private Turret turret4;
    private Turret turret5;
    private Turret turret6;
    private int numberOfFighters = 0;
    private int launchCooldown = 100;
    /**
     * Act - do whatever the ship wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move();
        checkKeys();
        moveTurrets();
        launchFighter();
    }  
    /**
     * moves the turrets along with the ship
     */
    public void moveTurrets()
    {
        turret1.setLocation(getX(),getY());
        turret1.setRotation(getRotation());
        turret1.move(-(getImage().getWidth()/2 -105 ));// +/- to move
        turret1.setRotation(getRotation()+90);
        turret1.move(-(getImage().getHeight()/2 -10 ));// + to move
        
        turret2.setLocation(getX(),getY());
        turret2.setRotation(getRotation());
        turret2.move(-(getImage().getWidth()/2 - 105));// +/- to move
        turret2.setRotation(getRotation()+90);
        turret2.move(-(getImage().getHeight()/2 -40 ));// + to move
        
        turret3.setLocation(getX(),getY());
        turret3.setRotation(getRotation());
        turret3.move(-(getImage().getWidth()/2 -90));// +/- to move
        turret3.setRotation(getRotation()+90);
        turret3.move(-(getImage().getHeight()/2 -10));// + to move
        
      
        turret4.setLocation(getX(),getY());
        turret4.setRotation(getRotation());
        turret4.move(-(getImage().getWidth()/2 -90));// +/- to move
        turret4.setRotation(getRotation()+90);
        turret4.move(-(getImage().getHeight()/2 -40 ));// + to move
     
        turret5.setLocation(getX(),getY());
        turret5.setRotation(getRotation());
        turret5.move(-(getImage().getWidth()/2  -75));// +/- to move
        turret5.setRotation(getRotation()+90);
        turret5.move(-(getImage().getHeight()/2 -10));// + to move
        
        turret6.setLocation(getX(),getY()); 
        turret6.setRotation(getRotation());
        turret6.move(-(getImage().getWidth()/2  -75));// +/- to move
        turret6.setRotation(getRotation()+90);
        turret6.move(-(getImage().getHeight()/2 -40 ));// + to move
    }
    
    /**
     * puts the turrets on the ship
     */
    public void setTurret(Turret turret1,Turret turret2,Turret turret3,Turret turret4,Turret turret5,Turret turret6)  
    {  
        this.turret1 = turret1;
        getWorld().addObject(turret1,getX(),getY());

        this.turret2 = turret2;
        getWorld().addObject(turret2,getX(),getY());

        this.turret3 = turret3;
        getWorld().addObject(turret3,getX(),getY());

        this.turret4 = turret4;
        getWorld().addObject(turret4,getX(),getY());
 
        this.turret5 = turret5;
        getWorld().addObject(turret5,getX(),getY());

        this.turret6 = turret6;
        getWorld().addObject(turret6,getX(),getY()); 
    }  
    /**
     * moves the ship and creats thrust particles
     */
    public void move()
    {
        if(Greenfoot.isKeyDown("w"))
        {
            for (Object obj : getWorld().getObjects(Star.class))
            {
                Star star = (Star) obj;
                star.move(getRotation());
            }
            
            Thrust flameL2 = new Thrust();
            getWorld().addObject(flameL2,getX(),getY());
            flameL2.setRotation(getRotation());
            flameL2.move(-(getImage().getWidth()/2 +5 ));// +/- to move
            flameL2.setRotation(getRotation()+90);
            flameL2.move(-(getImage().getHeight()/2 -12 ));// + to move
            flameL2.setRotation(getRotation()-10 + Greenfoot.getRandomNumber(20));
            
            Thrust flameR2 = new Thrust();
            getWorld().addObject(flameR2,getX(),getY());
            flameR2.setRotation(getRotation());
            flameR2.move(-(getImage().getWidth()/2 +5 ));// + to move
            flameR2.setRotation(getRotation()+90);
            flameR2.move(-(getImage().getHeight()/2 -37 ));// + to move
            flameR2.setRotation(getRotation()-10 + Greenfoot.getRandomNumber(20));
            
            Thrust flameL1 = new Thrust();
            getWorld().addObject(flameL1,getX(),getY());
            flameL1.setRotation(getRotation());
            flameL1.move(-(getImage().getWidth()/2 -15 ));// + to move
            flameL1.setRotation(getRotation()+90);
            flameL1.move(-(getImage().getHeight()/2 -8 ));// + to move
            flameL1.setRotation(getRotation()-10 + Greenfoot.getRandomNumber(20));
            
            Thrust flameR1 = new Thrust();
            getWorld().addObject(flameR1,getX(),getY());
            flameR1.setRotation(getRotation());
            flameR1.move(-(getImage().getWidth()/2 -15 ));// + to move
            flameR1.setRotation(getRotation()+90);
            flameR1.move(-(getImage().getHeight()/2 -40 ));// + to move
            flameR1.setRotation(getRotation()-10 + Greenfoot.getRandomNumber(20));     
            
        }
    }
    /**
     * The ship checks the Keys from the Keyboard.
     * Depending on the keys it turns right/left 
     */
    public void checkKeys()
    {
            if(Greenfoot.isKeyDown("w"))
            {
                this.move(3);
            }
            if(Greenfoot.isKeyDown("d"))
            {
                setRotation(getRotation()+1);
            }
            if(Greenfoot.isKeyDown("a"))
            {
                setRotation(getRotation()-1);
            }
    }
    /**
     * Launches fighters and checks to see how many there are currently
     */
    public void launchFighter()
    {
        Fighter fighter = new Fighter(this);
        if(Greenfoot.isKeyDown("Q") && numberOfFighters < 3 && launchCooldown <=0)
        {
            getWorld().addObject(fighter,getX(),getY());
            numberOfFighters++;
            launchCooldown = 100;
        }
        launchCooldown--;
    }
}
