import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class EnemyFighter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class EnemyFighter extends Enemy
{
    private EnemyCrusier enemyCrusier;  
    private int hull = 3;
    public EnemyFighter(EnemyCrusier enemyBaseShip) // receives Ship object  
    {  
        enemyCrusier = enemyBaseShip; // sets instance field for 'this' object  
    }  
    /**
     * Act - do whatever the Fighter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move(3); 
        wander();
        depleteHull();
        destroy();
    }    
     /**
     * wander around capital ship
     */
    public void wander()
    { 
        if(getDistanceFromShip(enemyCrusier) > 80.0)
        {
            setRotation(getRotation() + 3);
        }  
    }
    /**
     * returns distance from ship
     */
    public double getDistanceFromShip(EnemyCrusier enemyCrusier)
    {
        //Fix This
       return Math.sqrt(Math.pow(getX()-enemyCrusier.getX(),2)+Math.pow(getY()-enemyCrusier.getY(),2)); 
    }   
    public void destroy()
    {
        if(hull<=0)
        {
            getWorld().removeObject(this); 
        }
    }
     public void depleteHull()
     {
         if(getWorld() != null)
        {
         Actor Laser= getOneIntersectingObject(Laser.class);
         if(Laser != null)
         {
                 hull--;
         }
        }
   }
}
